unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, DBCtrls, DB, ADODB, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    ADOQueryDict: TADOQuery;
    ADOQueryDictTableName: TWideStringField;
    ADOQueryDictDisplayName: TWideStringField;
    ADOQueryDictEngine: TWideStringField;
    ADOQueryDictAccount: TWideStringField;
    ADOQueryDictPassword: TWideStringField;
    ADOQueryDictCatalog: TWideStringField;
    ADOQueryDictSource: TWideStringField;
    ADOQueryDictHint: TWideStringField;
    DataSourceDict: TDataSource;
    ADOQuerySpec: TADOQuery;
    ADOQuerySpecTableName: TWideStringField;
    ADOQuerySpecFieldName: TWideStringField;
    ADOQuerySpecFieldType: TIntegerField;
    ADOQuerySpecFieldLen: TIntegerField;
    ADOQuerySpecFieldDec: TIntegerField;
    ADOQuerySpecDisplayName: TWideStringField;
    ADOQuerySpecftype: TStringField;
    ADOQuerySpecfHInt: TStringField;
    DataSourceSpec: TDataSource;
    ADOQueryFieldType: TADOQuery;
    ADOConnection1: TADOConnection;
    Panel1: TPanel;
    Label1: TLabel;
    DBLookupComboBox1: TDBLookupComboBox;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ScrollBox1: TScrollBox;
    PopupMenu1: TPopupMenu;
    Delete1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure ScrollBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Delete1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    co:integer;
    now_rela:integer;  //ƹSҫ쪺
  end;

var
  Form1: TForm1;
  hdcv:HDC;
  rela:array[1..100,1..2] of string;  //̦h100p;  1->m 2->d
  relafield:array[1..100,1..3] of integer;  //1->mfieldpos 2->dfiendpoa  3->rela
  relaco:integer; //counter;
  order_by,group_by,Where_and:TStringlist;
  function compute_on_rela_line(Master:Tobject;x,y:integer):integer;
  function on_rela_Line(x,y,x1,x2,y1,y2:integer):boolean;
  procedure drrela(x1,y1,x2,y2:integer;co:tcolor);
  procedure redrrela(Master:Tobject;co:integer);
  procedure freetp(Master:Tobject;co:string);
  procedure freerela(Master:Tobject;co:integer);

implementation

uses testframe;

{$R *.dfm}
function on_rela_Line(x,y,x1,x2,y1,y2:integer):boolean;
var mm:real;
    te:integer;
begin
   result:=false;
   if ((y1+1>=y) and (y>=y1-1) and (x>=x1) and (x<=x1+15)) or
      ((y2+1>=y) and (y>=y2-1) and (x<=x2) and (x>=x2-15)) then
      result:=true
   else
   begin
      x1:=x1+15;
      x2:=x2-15;
      if (abs(x1-x2)<=1) then
      begin
         if (((y>=y1) and (y<=y2)) or ((y>=y2) and (y<=y1))) then
            result:=true;
         end else
      begin
         mm:=(y2-y1)/(x2-x1);
         te:=trunc(y1+mm*(x-x1));
         if abs(y-te)<=2 then
            result:=true;
      end;
   end;
end;

function compute_on_rela_line(Master:Tobject;x,y:integer):integer;
var i:integer;
    TPS1,TPS2:TTP;
    s:string;
    x1,x2,y1,y2:integer;
    fi:boolean;
begin
   result:=1;
   fi:=false;
   while (result<=relaco) and (not fi) do
   begin
      s:='TP'+rela[result,1];
      TPS1:=TTP(TControl(Master).FindComponent(s));
      s:='TP'+rela[result,2];
      TPS2:=TTP(TControl(Master).FindComponent(s));
      x1:=TPS1.left+TPS1.width;
      y1:=TPS1.top+12;
      x2:=TPS2.left;
      y2:=TPS2.top+12;
      fi:=on_rela_Line(x,y,x1,x2,y1,y2);
      if not fi then
         result:=result+1;
   end;
end;

procedure drrela(x1,y1,x2,y2:integer;co:tcolor);
var PenObject:hpen;
begin
   PenObject:=CreatePen(PS_SOLID,2,co);
   SelectObject(hdcv,PenObject);
   MoveToEx(hdcv,x1,y1,nil);
   LineTo(hdcv,X1+15, Y1);
   MoveToEx(hdcv,X1+15,Y1,nil);
   LineTo(hdcv,X2-15, Y2);
   MoveToEx(hdcv,X2-15,Y2,nil);
   LineTo(hdcv,X2, Y2);
end;

procedure redrrela(Master:Tobject;co:integer);
var i:integer;
    TPS1,TPS2:TTP;
    s:string;
begin
   TControl(Master).Refresh;
   for i:=1 to co do
   begin
      s:='TP'+rela[i,1];
      TPS1:=TTP(TControl(Master).FindComponent(s));
      s:='TP'+rela[i,2];
      TPS2:=TTP(TControl(Master).FindComponent(s));
      drrela(TPS1.left+TPS1.width,TPS1.top+12,TPS2.left,TPS2.Top+12,clBlue);
   end;
end;

procedure freerela(Master:Tobject;co:integer);
var i:integer;
    TPS:TTP;
    s:string;
    relas,relad:string;
begin
   relas:=rela[co,1];
   relad:=rela[co,2];
   for i:=co+1 to relaco do
   begin
     rela[i-1,1]:=rela[i,1];
     rela[i-1,2]:=rela[i,2];
     relafield[i-1,1]:=relafield[i,1];
     relafield[i-1,2]:=relafield[i,2];
     relafield[i-1,3]:=relafield[i,3];
   end;
   relaco:=relaco-1;
   s:='TP'+relas;
   TPS:=TTP(TControl(Master).FindComponent(s));
   TPS.CheckListBox1.repaint;
   s:='TP'+relad;
   TPS:=TTP(TControl(Master).FindComponent(s));
   TPS.CheckListBox1.repaint;
   redrrela(Master,relaco);
end;

procedure freetp(Master:Tobject;co:string);
var i,j:integer;
begin
   j:=1;
   while j<=relaco do
   begin
      if (rela[j,1]=co) or (rela[j,2]=co) then
      begin
         freerela(Master,j);
      end else
         j:=j+1;
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   co:=0;
   relaco:=0;
   hdcv:=GetDC(ScrollBox1.Handle);
   order_by:=TStringList.Create;
   group_by:=TStringList.Create;
   Where_and:=TStringList.Create;
end;

procedure TForm1.ScrollBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if Button=mbLeft then
   begin
      co:=co+1;
      crTP(sender,ADOQuerySpec,ADOQueryDict.fieldbyname('DisplayName').asstring,ADOQueryDict.fieldbyname('TableName').asstring,'TP'+inttostr(co),Y,X,108,112);
   end else
   begin
      now_rela:=compute_on_rela_line(sender,x,y);
      if now_rela<=relaco then
         ScrollBox1.PopupMenu:=PopupMenu1
      else
         ScrollBox1.PopupMenu:=nil;
   end;
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
   freerela(PopupMenu1.PopupComponent,now_rela);
end;

end.
