unit testframe;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, CheckLst, Menus, ImgList, DB, ADODB;

type
  TTP = class(TFrame)
    Panel1: TPanel;
    Image1: TImage;
    CheckBox1: TCheckBox;
    CheckListBox1: TCheckListBox;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    ImageList1: TImageList;
    Where1: TMenuItem;
    Group1: TMenuItem;
    Order1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure N1Click(Sender: TObject);
    procedure CheckListBox1DragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure CheckListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Image1Click(Sender: TObject);
    procedure CheckListBox1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure CheckListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    mv:boolean;
    dx,dy:integer;
    display_name,table_name:string;
    changech:boolean;
    order_by,group_by,Where_and:TStringlist;
  end;
  procedure crTP(sender:TObject;ADOQ:TADOQuery;d_name,t_name,c_name:string;t_top,t_left,t_height,t_width:integer);

implementation

uses Unit1;



{$R *.dfm}
procedure crTP(sender:TObject;ADOQ:TADOQuery;d_name,t_name,c_name:string;t_top,t_left,t_height,t_width:integer);
begin
   With TTP.Create(TComponent(sender)) do
   begin
      name:=c_name;
      Parent:=TWinControl(sender);
      Top:=T_top;
      Left:=T_Left;
      Height:=T_Height;
      Width:=T_width;
      Panel1.Caption:=d_name;
      table_name:=t_name;
      display_name:=d_name;
      imagelist1.GetBitmap(0,image1.Picture.Bitmap);
      image1.Refresh;
      CheckListBox1.Items.Clear;
      ADOQ.first;
      While not ADOQ.Eof do
      begin
         CheckListBox1.items.Add(ADOQ.fieldbyname('DisplayName').asstring+' ('+inttostr(ADOQ.fieldbyname('FieldLen').asinteger)+')');
         CheckListBox1.checked[CheckListBox1.Items.Count-1]:=True;
         ADOQ.Next;
      end;
      CheckBox1.Checked:=True;
   end;
end;

procedure TTP.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   N1.Visible:=True;
   Where1.Visible:=false;
   Group1.Visible:=false;
   Order1.Visible:=false;
   mv:=true;
   dx:=Mouse.CursorPos.X;
   dy:=Mouse.CursorPos.Y;
end;

procedure TTP.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if mv then
   begin
      TWinControl(Sender).Parent.Left:=TWinControl(Sender).Parent.Left+Mouse.CursorPos.X-dx;
      TWinControl(Sender).Parent.Top:=TWinControl(Sender).Parent.Top+Mouse.CursorPos.Y-dy;
      dx:=Mouse.CursorPos.X;
      dy:=Mouse.CursorPos.Y;
      redrrela(Tcontrol(sender).Parent.Parent,relaco);
   end;
end;

procedure TTP.Panel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   mv:=false;
end;

procedure TTP.N1Click(Sender: TObject);
begin
   freetp(self.Parent,copy(tcontrol(self).name,3,length(tcontrol(self).name)-2));
   redrrela(Tcontrol(self).Parent,relaco);
   self.Free;
end;

procedure TTP.CheckListBox1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var APoint: TPoint;
begin
   apoint.x:=x;
   apoint.y:=y;
   if not (source=sender) and (tCheckListBox(sender).itematpos(apoint,true)>=0) then
   begin
      relaco:=relaco+1;
      rela[relaco,1]:=copy(tcontrol(source).Parent.name,3,length(tcontrol(source).Parent.name)-2);
      rela[relaco,2]:=copy(tcontrol(sender).Parent.name,3,length(tcontrol(sender).Parent.name)-2);
      relafield[relaco,1]:=tCheckListBox(source).itemindex;
      relafield[relaco,2]:=tCheckListBox(sender).itematpos(apoint,true);
      relafield[relaco,3]:=1;
      redrrela(TControl(Sender).parent.Parent,relaco);
      tCheckListBox(source).repaint;
      tCheckListBox(sender).repaint;
   end;
//   apoint.x:=x;
//   apoint.y:=y;
//   tCheckListBox(sender).Items.Insert(tCheckListBox(sender).itematpos(apoint,true),tListBox(source).items[tListBox(source).itemindex]);
//   tCheckListBox(source).Items.Delete(tCheckListBox(source).itemindex);
end;

procedure TTP.CheckListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
   accept:=true;
end;

procedure TTP.Image1Click(Sender: TObject);
begin
   if tcontrol(sender).parent.Height<tcontrol(sender).parent.Parent.Height then
   begin
      tcontrol(sender).parent.Parent.Height:=tcontrol(sender).parent.Height;
      imagelist1.GetBitmap(1,timage(sender).Picture.Bitmap);
      timage(sender).Refresh;
   end else
   begin
      tcontrol(sender).parent.Parent.Height:=112;
      imagelist1.GetBitmap(0,timage(sender).Picture.Bitmap);
      timage(sender).Refresh;
   end;
end;

procedure TTP.CheckListBox1Click(Sender: TObject);
var ch:boolean;
    i:integer;
begin
   ch:=True;
   with tCheckListBox(sender) do
   begin
      for i:=0 to items.count-1 do
        ch:=ch and checked[i];
   end;
   changech:=true;
   checkbox1.checked:=ch;
   changech:=false;
end;

procedure TTP.CheckBox1Click(Sender: TObject);
var i:integer;
begin
   with CheckListBox1 do
   begin
      if not changech then
      begin
         for i:=0 to items.count-1 do
           checked[i]:=Tcheckbox(sender).Checked;
      end;
   end;
   changech:=true;
end;

procedure TTP.CheckListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var i:integer;
    fi:boolean;
begin
   i:=1;
   fi:=false;
   while (i<=relaco) and not fi do
   begin
      if ((rela[i,1]=copy(self.Name,3,length(self.Name)-2)) and (relafield[i,1]=index)) or
         ((rela[i,2]=copy(self.Name,3,length(self.Name)-2)) and (relafield[i,2]=index)) then
         fi:=true
      else
         i:=i+1;
   end;
   if fi then
   begin
      with (Control as TcheckListBox).Canvas do
      begin
         font.Style:=font.Style + [fsBold];
         TextOut(Rect.Left, Rect.Top, (Control as TchecklistBox).Items[Index]);  { display the text }
      end;
   end else
   begin
      with (Control as TcheckListBox).Canvas do
      begin
         font.Style:=font.Style - [fsBold];
         TextOut(Rect.Left, Rect.Top+2, (Control as TchecklistBox).Items[Index])  { display the text }
      end;
   end;
end;

procedure TTP.CheckListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   N1.Visible:=false;
   Where1.Visible:=True;
   Group1.Visible:=True;
   Order1.Visible:=True;
end;

end.
